##################################################################
# This program partition the sequences in the source directoyr into 
# two subdirectory, the training and the testing,
# the former obtains 2/3 and the later has 1/3 if (k=3).
# 2006.4.12
# 2007.2.7 New directory Name Collection using jdwnagPackage.pm
#			Train=(k-1)/k, Test= 1/k
# jdwang@asia.edu.tw
##################################################################
use strict;
use lib "./jdwang_lib/";
use jdwangPubMedPackage3;
use Data::Dumper;

die "Usage: perl 10DataDivideIntoTrainTestNew_ForVec.pl <Directory> <k> \n" unless @ARGV == 3;
# perl 10DataDivideIntoTrainTestNew_ForVec.pl "./ClassVector" 4 "./ClassVector_BatchSVM/"
#
#
#
my $SrcLocationDir = $ARGV[0];

my ($Constrain) = $SrcLocationDir =~ /\.\/(.+)/;
#print Dumper($Species,$Constrain);exit;

my $k = $ARGV[1];
my $OutputEasySVMBatchDir = $ARGV[2] ;
mkdir $OutputEasySVMBatchDir;
my $OutputFile = $OutputEasySVMBatchDir."Easypy_".$Constrain."fold$k".".txt";
#print Dumper($OutputFile);exit;
open (output,">$OutputFile") or die "can't open $OutputFile";
#
# Remove all the files under $TrainTestDir
#

#
# Extract the seq files names from the Dir specified by the user 
#
my @SegFileAry = ();
my $SeqFilesCnt = jdwangPubMedPackage3::DirFilenames($SrcLocationDir,\@SegFileAry);
print "The number of files in $SrcLocationDir=> $SeqFilesCnt\n"; 

#
# Output the fieldnames for the information of the sequences
#
my $TrainTestDir = $Constrain.$k."Fold_Temp/";
#my $TrainTestDir = $SourceDir."_Temp/";
mkdir $TrainTestDir;

for (my $p=0;$p<$k;$p++) {
	my $Train = "_Train".$k."_".$p;
	my $Test = "_Test".$k."_".$p;
	#mkdir $TrainDir;
	#mkdir $TestDir;

	for (my $i=0;$i<$#SegFileAry+1;$i++)
	{
		#print "$SegFileAry[$i]\n";
		
		#print Dumper($TempFile);exit;
		my $InputFile = "$SrcLocationDir/".$SegFileAry[$i]; 
		open FILEHANDLE, $InputFile or die "can't not open $InputFile\n";
		
		my ($TempFile) = $SegFileAry[$i] =~ /(.+)\..+/;
		my $OutputFile_Train = $TrainTestDir.$TempFile.$Train.".txt"; 
		open (OutTrainHandle,">$OutputFile_Train") or die "can't not open $OutputFile_Train\n";
		
		my $OutputFile_Test = $TrainTestDir.$TempFile.$Test.".txt";
		open (OutTestHandle,">$OutputFile_Test") or die "can't not open $OutputFile_Test\n";
		
		my $SeqCnt = 0;
		while (my $line = <FILEHANDLE>)
		{
			#if ($line =~ />/) {  
			$SeqCnt++;		
			#} 
			if (($SeqCnt % $k) != $p )
			{
				print OutTrainHandle $line;
			} else { 
				print OutTestHandle $line;
			}
		} # end of while 
		close (FILEHANDLE);	
		close OutTrainHandle;
		close OutTestHandle;
				
		print output "easy.py ../../$OutputFile_Train ../../$OutputFile_Test\n";
	} # end of for (my $i=0;$i<$#SegFileAry+1;$i++)
} # end of for (my $p=0;$p<$k;$p++)
