# jdwang@asia.edu.tw
# 2010.11.20
# 2010.11.28
# 2010.12.20
# 2011.2.6
# 2011.4.8
# 2012.7.25

use strict;
use Data::Dumper;
#use lib "./Program/";
#use jdwang_Liblinear;

die "Usage: perl ComputeResultStatistics_Region_1.pl <SrcTestDir> <TestFileTag> <PredictFileDir> <Fold>" unless @ARGV == 5;

#perl ComputeResultStatistics_PubMed.pl ./ClassVector4Fold_Temp "SrcParsedData_TopTFIDF_10000_Test" ./libsvm-3.20/tools/  "./ExperimentalResults/" 4

my $TestFileDir = $ARGV[0];
my $PatternFileTag = $ARGV[1];
my $PredictFileDir = $ARGV[2];
my $ResultDir = $ARGV[3];
my $fold = $ARGV[4];


mkdir $ResultDir;

my %TotalAverage = ();
my %TotalConfusionMatrix = ();
for (my $i=0;$i<$fold;$i++) {
	#Test5_0_Kmer1_VM6
	my $TestFileName = $PatternFileTag.$fold."_".$i.".txt";
	my $PredictFile = $TestFileName.".predict";	
	my $TestFileLocation = $TestFileDir."\/".$TestFileName;
	my $PredictFileLocation = $PredictFileDir.$PredictFile;	
	#print Dumper($TestFileLocation,$PredictFileLocation);exit;	
	my %ClassInstanceCnt = ();
	FindClassInstanceCnt($TestFileLocation,\%ClassInstanceCnt);
	#print Dumper(%ClassInstanceCnt);exit;
	my %ConfusionMatrix = ();
	my $Accuracy = ComputeConfusionMatrixFromOutputFile($TestFileLocation,$PredictFileLocation,\%ConfusionMatrix);	
	AddHash_ConfusionMatrix(\%TotalConfusionMatrix,\%ConfusionMatrix);	
} # end of for (my $i=0;$i<$fold;$i++)
my %Recall = ();
my %Precision = ();
my %F1= ();
my %TotalAverage = ();
my $StatisticsFileLocation = $ResultDir.$PatternFileTag."_ClassificationResult.txt";
my $PredictFileLocation = $ResultDir.$PatternFileTag;
ComputeClassificationStatistics(\%TotalConfusionMatrix,\%Recall,\%Precision,\%F1,\%TotalAverage,$StatisticsFileLocation,$PredictFileLocation);
###############################################################################################
my $TotalConfusionMatrixFile = $ResultDir.$PatternFileTag."_TotalConfusionMatrix.txt";
OutputConfusionMatrixFile($TotalConfusionMatrixFile,\%TotalConfusionMatrix,\%Precision,\%Recall);

#my $TotalConfusionMatrixFile = $ResultDir.$PatternFileTag."_TotalConfusionMatrix_NonZero.txt";
#OutputConfusionMatrixFile_NonZero($TotalConfusionMatrixFile,\%TotalConfusionMatrix,\%Precision,\%Recall);

#my $TotalConfusionMatrixFileForLatex = $ResultDir.$PatternFileTag."_TotalConfusionMatrixForLatex.txt";
#OutputConfusionMatrixFileForLatexTable($TotalConfusionMatrixFileForLatex,\%TotalConfusionMatrix);
#my $Threshold = 1;
#my $TotalConfusionMatrixFile_Error_ForLatex = $ResultDir.$PatternFileTag."_ConfusionMatrix_PR_Under".$Threshold."_ForLatex.txt";
#OutputConfusionMatrixFile_Error_ForLatexTable($TotalConfusionMatrixFile_Error_ForLatex,\%TotalConfusionMatrix,\%Precision,\%Recall,$Threshold);
#$Threshold = 0.60;
#$TotalConfusionMatrixFile_Error_ForLatex = $ResultDir.$PatternFileTag."_ConfusionMatrix_PR_Under".$Threshold."_ForLatex.txt";
#OutputConfusionMatrixFile_Error_ForLatexTable($TotalConfusionMatrixFile_Error_ForLatex,\%TotalConfusionMatrix,\%Precision,\%Recall,$Threshold);
#$Threshold = 0.50;
#$TotalConfusionMatrixFile_Error_ForLatex = $ResultDir.$PatternFileTag."_ConfusionMatrix_PR_Under".$Threshold."_ForLatex.txt";
#OutputConfusionMatrixFile_Error_ForLatexTable($TotalConfusionMatrixFile_Error_ForLatex,\%TotalConfusionMatrix,\%Precision,\%Recall,$Threshold);

my $TotalStatisticFile = $ResultDir."/Region_SVMClassification_Statistics.txt";

if (! -e ($TotalStatisticFile)) {
	open (output,">>$TotalStatisticFile") or die "can't open $TotalStatisticFile";
	print output "PatternFile\tfold\tAccuracy\tRecall\tPrecision\tF1\n";
} else {
	open (output,">>$TotalStatisticFile") or die "can't open $TotalStatisticFile";	
}
print output "$PatternFileTag\t$fold\t$TotalAverage{'Accuracy'}\t$TotalAverage{'Recall'}\t$TotalAverage{'Precision'}\t$TotalAverage{'F1'}\n";
close(output);

#################################################################
sub AddHash_ConfusionMatrix {		
	my ($TotalConfusionMatrix,$ConfusionMatrix) = @_;	
	foreach my $OneCID ( keys %{$ConfusionMatrix}) {
		#print Dumper($OneCID);#exit;
		foreach my $ClassifiedCID ( keys %{$ConfusionMatrix->{$OneCID}}) {
		 	$TotalConfusionMatrix->{$OneCID}->{$ClassifiedCID} += $ConfusionMatrix->{$OneCID}->{$ClassifiedCID};		 	
		} # end of 
	} # end of foreach my $OneCID (sort keys %$ConfusionMatrix)
}
#################################################################
sub ComputeClassificationStatistics {
	
	my ($ConfusionMatrix,$Recall,$Precision,$F1,$Average,$StatisticsFileLocation,$PredictFileLocation) = @_;
	
	#print Dumper(%$ConfusionMatrix);exit;
	
	my $TotalCnt = 0;
	
	my @ClassIDs = ();
	my $ClassIDIndex = 0;
	my %ClassInstancesCnt = ();
	foreach my $OneCID (sort {$a<=> $b} keys %{$ConfusionMatrix}) {
		#print Dumper($OneCID);#exit;
		#push (@ClassIDs,$OneCID);exit;@
		$ClassIDs[$ClassIDIndex] = $OneCID;
		$ClassIDIndex++;
		foreach my $ClassifiedCID (sort keys %{$ConfusionMatrix->{$OneCID}}) {
			$TotalCnt += $ConfusionMatrix->{$OneCID}->{$ClassifiedCID};
		 	$ClassInstancesCnt{$OneCID} += $ConfusionMatrix->{$OneCID}->{$ClassifiedCID};		 	
		} # end of 
	} # end of foreach my $OneCID (sort keys %$ConfusionMatrix)
	#
	# Compute the Precision of each class 
	#
	my %ClassifiedCIDCnt=();
	foreach my $OneClassifiedCID (@ClassIDs) {
		foreach my $OneCID (@ClassIDs){
			$ClassifiedCIDCnt{$OneClassifiedCID} += $ConfusionMatrix->{$OneCID}->{$OneClassifiedCID}
		}
	} # end of foreach my $OneClassifiedCID (@ClassIDs)
	#
	# Compute the Recall and Precision of each class 
	#
	my $CorrectCnt = 0;
	my $AverageRecall = 0;
	my $AveragePrecision = 0;
	my %F1 = ();
	my $AverageF1 = 0;
	foreach my $OneCID (@ClassIDs) {
		$CorrectCnt += $ConfusionMatrix->{$OneCID}->{$OneCID};
		$Recall->{$OneCID} = $ConfusionMatrix->{$OneCID}->{$OneCID}/$ClassInstancesCnt{$OneCID};
		if ($ClassifiedCIDCnt{$OneCID} != 0) {
			$Precision->{$OneCID} = $ConfusionMatrix->{$OneCID}->{$OneCID}/$ClassifiedCIDCnt{$OneCID};
		} else {
			$Precision->{$OneCID} = 0;
		} 
		#print "Recall->{$OneCID}=>$Recall->{$OneCID}\n";
		#print "Precision->{$OneCID}=>$Precision->{$OneCID}\n";
		$AverageRecall += $Recall->{$OneCID};
		$AveragePrecision += $Precision->{$OneCID};
		if (($Recall->{$OneCID}+$Precision->{$OneCID}) != 0) {
			$F1{$OneCID} = (2*$Recall->{$OneCID}*$Precision->{$OneCID})/($Recall->{$OneCID}+$Precision->{$OneCID});
		} else {
			$F1{$OneCID} =0;
		}
		$AverageF1 += $F1{$OneCID};
	}
	$AverageRecall = $AverageRecall/($#ClassIDs+1);
	$AveragePrecision = $AveragePrecision/($#ClassIDs+1);
	$AverageF1 = $AverageF1/($#ClassIDs+1);
	my $Accuracy = $CorrectCnt/$TotalCnt;
	
	open (output,">$StatisticsFileLocation"	) or die "can't open $StatisticsFileLocation";
	print output "TestFile\t$PredictFileLocation\n";
	print output "Accuracy\t$Accuracy\n";
	print output "ClassID\tRecall\tPrecision\tF1\n";
	foreach my $OneCID (@ClassIDs) {
		print output "$OneCID\t$Recall->{$OneCID}\t$Recall->{$OneCID}\t$F1{$OneCID}\n";	
	}
	print output "Average\t$AverageRecall\t$AveragePrecision\t$AverageF1\n";
	close(output);
	$Average->{"Accuracy"} = $Accuracy;
	$Average->{"Recall"} = $AverageRecall;
	$Average->{"Precision"} = $AveragePrecision;
	$Average->{"F1"} = $AverageF1;
} #end of sub ComputeClassificationStatistics
#################################################################################
# Compute the disticnt class lable
#################################################################################
sub FindClassInstanceCnt{
	my ($TestFile,$ClassLabel) = @_;
	open (TestFileHandle,"<$TestFile") or die "Can't open $TestFile";
	while (my $line = <TestFileHandle>) {
		#print Dumper($line);
		my @items = split (" ",$line);
		my $CID = $items[0];
		$ClassLabel->{$CID}++;
	}
	#print Dumper(%{$ClassLabel});exit;
	close(TestFileHandle);
}
#################################################################################
# initialize the value of Confusion Matrix
#################################################################################
sub InitConfusionMatrix{
	my ($TestFile,$ConfusionMatrix) = @_;
	my %ClassLabel =();
	FindDistinctClassLabel($TestFile,\%ClassLabel);
	#print Dumper(%ClassLabel);exit;
	foreach my $key1 (sort keys %ClassLabel){
		foreach my $key2 (sort keys %ClassLabel){
			$ConfusionMatrix->{$key1}->{$key2} = 0;
		}
	}
	#print Dumper(%ConfusionMatrix);exit;
}
#################################################################################
# Compute the disticnt class lable
#################################################################################
sub FindDistinctClassLabel{
	my ($TestFile,$ClassLabel) = @_;
	open (TestFileHandle,"<$TestFile") or die "Can't open $TestFile";
	while (my $line = <TestFileHandle>) {
		#print Dumper($line);
		my @items = split (" ",$line);
		my $CID = $items[0];
		$ClassLabel->{$CID}++;
	}
	#print Dumper(%{$ClassLabel});exit;
	close(TestFileHandle);
}
#################################################################################
# Compute the Confusion Matric according to the "TestFile" and the "PredictFile"
#################################################################################
sub ComputeConfusionMatrixFromOutputFile{
	my ($TestFile,$PredictFile,$ConfusionMatrix) = @_;
	
	InitConfusionMatrix($TestFile,$ConfusionMatrix);
	
	open (TestFileHandle,"<$TestFile") or die "Can't open $TestFile";
	open (PredictFileHandle,"<$PredictFile") or die "Can't open $PredictFile";
	my $cnt = 0;
	my $CorrectCnt = 0;
	while (my $line = <TestFileHandle>) {
		$cnt++;
		#print Dumper($cnt);
		#print $line;exit;
		#my @items = split / /,$line;
		#print "\n$items[0]\n";exit;
		#
		my @items = split (" ",$line);
		my $CID = $items[0];
		#my ($CID,$VectorStr) = $line =~ /(\w+) (.+)/g;
		#print Dumper($CID);
		
		my $ans = <PredictFileHandle>;
		chomp($ans);
		$ConfusionMatrix->{$CID}->{$ans}++;
		#print Dumper($CID,$ans);exit;
		if ($CID == $ans) {
			$CorrectCnt++;
			#print "$CID == $ans\n";
		} else {
			#print "$CID != $ans\n";
		}
	} # end of while (my $line = <TestFileHandle>)
	my $Accuracy = $CorrectCnt/$cnt;
	#print Dumper($cnt,$CorrectCnt,$Accuracy);exit;
	
	#print "$cnt $CorrectCnt $Accuracy\n";
	close(TestFileHandle);
	close(PredictFileHandle);
	#print Dumper($ConfusionMatrix);
	my $AccuracyStr = sprintf("%1.3f",$Accuracy);
	#print Dumper($AccuracyStr);exit;
	#return($AccuracyStr);
	return($Accuracy);
}
#################################################################################
# Output the confuction matrix to file
#################################################################################
sub OutputConfusionMatrixFile {
	my ($ConfusionMatrixFile,$ConfusionMatrix,$Precision,$Recall) = @_;
	
	my @SortList;
	SortHashKey_Num($ConfusionMatrix,\@SortList);
	
	open (output,">$ConfusionMatrixFile") or die "can't open $ConfusionMatrixFile";
	print output " ";
	foreach my $key1 (@SortList){
		print output "#$key1";
	}
	print output "#Recall\n";
	foreach my $key1 (@SortList){
		print output "$key1";
		foreach my $key2 (@SortList){
			print output "#$ConfusionMatrix->{$key1}->{$key2}";
		}
		print output "#".sprintf("%1.3f",$Recall{$key1})."\n";
	}
	print output "Precision";
	foreach my $key1 (@SortList){
		print output "#".sprintf("%1.3f",$Precision{$key1});
	}
	close(output);
}

#################################################################################
# Output the confuction matrix to file
#################################################################################
sub OutputConfusionMatrixFile_NonZero {
	my ($ConfusionMatrixFile,$ConfusionMatrix,$Precision,$Recall) = @_;
	
	my @SortList;
	SortHashKey_Num($ConfusionMatrix,\@SortList);
	
	open (output,">$ConfusionMatrixFile") or die "can't open $ConfusionMatrixFile";
	print output " ";
	foreach my $key1 (@SortList){
		print output "#$key1";
	}
	print output "#Recall\n";
	foreach my $key1 (@SortList){
		print output "$key1";
		foreach my $key2 (@SortList){
			if ($ConfusionMatrix->{$key1}->{$key2} != 0) {
				print output "#$ConfusionMatrix->{$key1}->{$key2}";
			} else {
				print output "# ";
			}
		} # end of foreach my $key2 (@SortList)
		print output "#".sprintf("%1.3f",$Recall{$key1})."\n";
	} # end of foreach my $key1 (@SortList)
	print output "Precision";
	foreach my $key1 (@SortList){
		print output "#".sprintf("%1.3f",$Precision{$key1});
	}
	close(output);
}
#######################################################################
#################################################################################
# Output the confuction matrix to file ForLatexTable
#################################################################################
sub OutputConfusionMatrixFileForLatexTable {
	my ($ConfusionMatrixFile,$ConfusionMatrix,$Precision,$Recall) = @_;
	
	my @SortList;
	SortHashKey_Num($ConfusionMatrix,\@SortList);
	
	open (output,">$ConfusionMatrixFile") or die "can't open $ConfusionMatrixFile";
	print output "{c";
	foreach my $key1 (@SortList){
		print output "c";
	}
	print output "c}\n";
	print output " ";
	foreach my $key1 (@SortList){
		print output "&C$key1";
	}
	print output "&Recall\\\\ \\hline \n";
	foreach my $key1 (@SortList){
		print output "C$key1";
		foreach my $key2 (@SortList){
			print output "&$ConfusionMatrix->{$key1}->{$key2}";
		}	
		print output "&".sprintf("%1.2f",$Recall{$key1})."\\\\\n";
	}
	print output "\\hline \n";
	print output "Precision";
	foreach my $key1 (@SortList){
		print output "&".sprintf("%1.2f",$Precision{$key1});
	}
	print output "\\\\";
	close(output);
}
#################################################################################
# Output the confuction matrix to file ForLatexTable
#################################################################################
sub OutputConfusionMatrixFile_Error_ForLatexTable {
	my ($ConfusionMatrixFile,$ConfusionMatrix,$Precision,$Recall,$Threshold) = @_;
	#print Dumper($Precision,$Recall);exit;
	my @SortList = ();
	SortHashKey_Num($ConfusionMatrix,\@SortList);
	#print Dumper(@SortList);exit;
	#print Dumper($Threshold);exit;
	#print Dumper($Recall,$Precision);exit;
	my @SortList_Error=();
	foreach my $key1 (@SortList){
		if (($Recall{$key1} > $Threshold)&&($Precision{$key1} > $Threshold)) {
			#print "No! $key1=>($Recall{$key1},$Precision{$key1})\n";
		} else {
			#print "Yes! $key1=>($Recall{$key1},$Precision{$key1})\n";
			push  @SortList_Error, $key1;			
		}
	} # end of foreach my $key1 (@SortList)
	#print Dumper(@SortList_Error);exit;
	
	###################################################################################
	#SortHashKey_Num($ConfusionMatrix,\@SortList_Error);
	open (output,">$ConfusionMatrixFile") or die "can't open $ConfusionMatrixFile";
	print output "{c";
	foreach my $key1 (@SortList_Error){
		print output "c";
	}
	print output "c}\n";
	print output " ";
	foreach my $key1 (@SortList_Error){
		print output "&\$C"."_"."\{$key1\}\$";
	}
	print output "&Recall\\\\ \\hline \n";
	foreach my $key1 (@SortList_Error){
		print output "\$C"."_"."\{$key1\}\$";
		foreach my $key2 (@SortList_Error){
			print output "&$ConfusionMatrix->{$key1}->{$key2}";
		}	
		print output "&".sprintf("%1.2f",$Recall{$key1})."\\\\\n";
	}
	print output "\\hline \n";
	print output "Precision";
	foreach my $key1 (@SortList_Error){
		print output "&".sprintf("%1.2f",$Precision{$key1});
	}
	print output "\\\\";
	close(output);
}
#######################################################################
# Compute the disticnt class lable
#######################################################################
sub SortHashKey_Num {
  my ( $Testhash, $SortList ) = @_;
  @{$SortList} = sort {$a <=> $b} keys %{$Testhash};
}
#######################################################################

