
#perl InstancesVectorTransform11.pl ./SrcStatistics/SrcFileStatistics.txt ./SrcParsedData ./PatternWithWeights/Pattern_Top_Log(TF)IDF_ICF_LimitCnt10000.txt  ./OutputVector/SrcParsedData_Top_Log(TF)IDF_ICF_LimitCnt10000_Vector.txt


use strict;
use Data::Dumper;
use jdwangPubMedPackage3;
use FileHandle;

my $SrcFileStatisticsFile = $ARGV[0];
my $SrcDocumentDir = $ARGV[1];
my $PatternWeightFile = $ARGV[2];
my $OutputFile = $ARGV[3];

#
#
#
my %FileNameToID = ();
my $fh_FileStatistics = new FileHandle($SrcFileStatisticsFile,"r") or die "can't open $SrcFileStatisticsFile";
#ID	FileName	NumOfArticles
#1	epi+mirna_Parsed.txt	1996
my $TitleLine = <$fh_FileStatistics>;
while (my $Line = <$fh_FileStatistics>) {
	chomp($Line);
	my @Items = split (/\t/,$Line);
	my $ID = $Items[0];
	my $FileName = $Items[1];
	my $ArticlesNum = $Items[2];	
	$FileNameToID{$FileName} = $ID;
}


$fh_FileStatistics->close();
#
# read the IDF weight of selected patterns
#
my %ID2Pattern = ();
my %PatternID = ();
my %PatternIDF = ();
my %PatternIDF_RegularExpression = ();
my $fh_stopword = new FileHandle($PatternWeightFile,"r") or die "can open $PatternWeightFile";
my $TtileLine = <$fh_stopword>; #Cnt	Pattern	TF	DF	IDF	TFxIDF
while (my $OnePatternInfo  = <$fh_stopword> ) {	
	#Cnt	Pattern	TF	DF	CF	IDF	log(TF)xIDFxICF	C1	C2	C3	C4
	#1	Dab2	1125	75	1	5.16463358135998	36.2843311069133	75	0	0	0
	chomp($OnePatternInfo);	
	my @Items = split ('\t',$OnePatternInfo);
	#print Dumper(@Items);exit;	
	my $OneID = $Items[0];
	my $OnePattern = $Items[1];
	my $OnePatternIDF = $Items[5];
	if ($OnePattern ne '') {
		$ID2Pattern{$OneID} = $OnePattern;
		$PatternID{$OnePattern} = $Items[0];
		$PatternIDF{$OnePattern} = $OnePatternIDF;			
		$PatternIDF_RegularExpression{$OnePattern} = RemoveControlChar($OnePattern);
	} 
} # end of while (my $OnePatternInfo  = <$fh_stopword> )
$fh_stopword->close();
#print Dumper(%PatternIDF);exit;


my $fh_output = new FileHandle($OutputFile,"w") or die "can open $OutputFile";
my %ArticleWordsStatistics = ();
#
# the number of articles
#
my $MissCnt = 0;
my $ArticleCnt = 0;
my @SegFileAry = ();
my $SeqFilesCnt = jdwangPubMedPackage3::DirFilenames($SrcDocumentDir,\@SegFileAry);
#print Dumper(@SegFileAry);exit;	
foreach my $OneFile (@SegFileAry) {
		my $ClassID = $FileNameToID{$OneFile};
	
		my $InputFileLocation  = $SrcDocumentDir."/".$OneFile;		
		#print "$InputFileLocation\n";		
			
		print "begin $OneFile ".scalar localtime(time())."\n";#exit;	
		
		my $fh_input = new FileHandle($InputFileLocation,"r");	
			
		my %OneArticleWordsStatistics = ();
		my $OneFileArticleCnt = 0;
		while (my $Line = <$fh_input>) {
			#25276143##2014-12-3##Fulminant Wilson's Disease Managed with Plasmapheresis as a Bridge to Liver Transplant.##New-onset jaundice can be a manifestation of multiple pathologic processes including hemolysis, parenchymal liver disease, and cholestasis; the differential diagnosis is broad and requires a systematic approach. We report a case of a patient who presented with jaundice after starting minocycline for the treatment of acne vulgaris and rapidly developed fulminant liver failure found to be due to Wilson's disease. She also manifested severe Coomb's negative hemolytic anemia and renal failure secondary to hepatorenal syndrome. As a bridge to liver transplant, she was successfully treated with plasmapheresis to decrease serum copper in addition to hemodialysis for acidosis and hyperkalemia. She was able to receive a liver and made a full recovery. The case highlights the use of plasmapheresis as an adjunctive treatment modality in cases of fulminant liver failure due to Wilson's disease.
			
			$ArticleCnt++;
			$OneFileArticleCnt++;
						
			chomp($Line);						
			my @Items = split (/\#\#/,$Line );
			#print Dumper(@Items);exit;
			my $PMID = $Items[0]; 
			#print "($ArticleCnt)PMID=>$PMID\n";
			my $Date = $Items[1];	
			my $Title = $Items[2];
			my $Abstract = $Items[3];		
			
			
			#$Title  =~ s/&quot//g;
			my $Content = $Title." ".$Abstract;
			#
			#my $Content = $Abstract;
			#print Dumper($Content);exit;
			print "$ArticleCnt($PMID)\n"; 
			
			my %OneVector = ();
			my %OneVectorID = ();
			my $MatchCnt = 0;
			foreach my $OnePattern (keys %PatternIDF) {
				my $wtf = 0;
							
				#while( $Content =~ /$OnePattern/g ) {
				while( $Content =~ /$PatternIDF_RegularExpression{$OnePattern}/g ) {
					$wtf++;
					#print "Match:$OnePattern($wtf)\n";
				}# end of while ($OnePattern =~ /$Content/g)		 
					
				if ($wtf != 0) {
					$MatchCnt++;
					$OneVector{$OnePattern} = $wtf;
					$OneVectorID{$PatternID{$OnePattern}} = $wtf;
				}# end of ($wtf != 0)			
			} # end of 
			if ($MatchCnt != 0){
				print $fh_output ("$ClassID ");#exit;
				
				#print Dumper(%OneVector);exit;
				#foreach my $OnePattern (sort keys %OneVector) {
				foreach my $OneID (sort {$a <=> $b} keys %OneVectorID) {
					my $OnePattern = $ID2Pattern{$OneID};
					my $PatternWeight = $OneVector{$OnePattern}*$PatternIDF{$OnePattern};
					#print $fh_output "#$OnePattern:$PatternWeight"; 
					print $fh_output " $OneID:".sprintf("%.4f", $PatternWeight);	
				} 
				print $fh_output "\n";#exit;
			} # end of if ($MatchCnt != 0)
			else {
				$MissCnt++;
				print "Miss Match=>$ArticleCnt($PMID)\n"; 
			}			
		} # end of while (my $Line = <$fh_input>)	
		$fh_input->close();	
			
		#print Dumper(%ArticleWordsStatistics);exit;	
		print "MissCnt/Total=($MissCnt/$OneFileArticleCnt) =>end $OneFile ".scalar localtime(time())."\n";
		#print Dumper(%ArticleStatistics);exit;		
} # end of foreach my $OneFile (@SegFileAry)
#print Dumper(%ArticleWordsStatistics);exit;

$fh_output->close();


####################################################
sub RemoveControlChar {
	my ($OnePattern) = @_;
	
	#if ($OnePattern =~ /\)/) {
	#	$OnePattern =~ s/\)/\\\)/g;
	#}
				
	#if ($OnePattern =~ /\(/) {
	#	$OnePattern =~ s/\(/\\\(/g;
	#}
				
	#if ($OnePattern =~ /\[/) {
	#	$OnePattern =~ s/\[/\\\[/g;
	#}
				
	#if ($OnePattern =~ /\]/) {
	#	$OnePattern =~ s/\]/\\\]/g;
	#}
				
	if ($OnePattern =~ /\*/) {
		$OnePattern =~ s/\*/\\\*/g;
	}
				
	if ($OnePattern =~ /\//) {
		$OnePattern =~ s/\//\\\//g;
	}
				
	if ($OnePattern =~ /\-/) {
		$OnePattern =~ s/\-/\\\-/g;
	}
				
	if ($OnePattern =~ /\+/) {
		$OnePattern =~ s/\+/\\\+/g;
	}	
	return($OnePattern);
} # end of sub RemoveControlChar
