#
# 2014.10.20 jdwang@asia.edu.tw
#
# usage : perl PubMed_InfoExtration_11_MultiDir_4.pl "../SrcData/SrcData_PubMed_PubDate" 1990 2014 "../SrcData_PubMed_PubDate_Parsed"


use strict;
use Data::Dumper;
use jdwangPubMedPackage3;
use DBI qw( :utils );
use FileHandle;

#
# connect to database
#
my $database = "pubmed_2014_10_20";
my $hostname = "localhost";
use constant DB_USER =>  "pubmed";
use constant DB_PASS =>  "pubmed123";
my $dns =  "DBI:mysql:database=".$database.";host=".$hostname;
my $dbh = DBI->connect( $dns, DB_USER, DB_PASS) or die "Connect failed: ", $DBI::errstr, ".\n";
$dbh->do("set character set utf8");



my $SrcDataDir = $ARGV[0];
my $StartYearDir = $ARGV[1];
my $EndYearDir = $ARGV[2];
my $OutPutDir = $ARGV[3];

mkdir $OutPutDir;

#
# 
#
for (my $i=$StartYearDir; $i <= $EndYearDir;$i++) {
	my $TargetDir = $SrcDataDir."/".$i;
	my @SegFileAry = ();
	my $SeqFilesCnt = jdwangPubMedPackage3::DirFilenames($TargetDir,\@SegFileAry);
	
	
	#open(OutputFilehandle,">$OutputFileLocation ") or die "can't open $OutputFileLocation";
	#my $fh_output = new FileHandle($OutputFileLocation, "a" );
	
	foreach my $OneFile (@SegFileAry) {
		my $InputFileLocation  = $TargetDir."/".$OneFile;		
		#print "($i)$OneFileLocation\n";		
		my ($OutputFileName,$ext) = $OneFile =~ /(.+)\.(\w+)?/;		
		#print "($i)$OutputFileLocation\n";
		my $OutputFileLocation = $OutPutDir."/".$OutputFileName."_Parsed.txt";
		
		print "begin $OneFile ".scalar localtime(time())."\n";#exit;	
			
		jdwangPubMedPackage3::ParsePubMed_XMLFile($dbh,$InputFileLocation,$OutputFileLocation);	
		
		print "end $OneFile ".scalar localtime(time())."\n";
				
	} # end of foreach my $OneFile (@SegFileAry)
} # end of for (my $i=$StartYearDir; $i <= $EndYearDir;$i++)


$dbh->disconnect;










