package jdwangPubMedPackage3;

use Data::Dumper;

#####################################################################
# 2014.10.13 jdwang@asia.edu.tw
#####################################################################
sub DirFilenames {
	
	my ($SrcDir,$SegFileAry) = @_;
	
	opendir (DIRHandle,$SrcDir) or die "Can't open directory=>$SrcDir";
		
	#my @SegFileAry = ();
	my $cnt=0;
	while (my $OneFileName = readdir DIRHandle)
	{
		
	  if ($OneFileName =~ /^\./)
	  {  	 
	  	# skip the "." and ".."
	  } else {
		  $cnt++;
	  	#print "($cnt)Directory=>$OneFileName\n";
		push (@$SegFileAry,$OneFileName);
	  }	
	}
	
	closedir DIRHandle;
	@$SegFileAry = sort @$SegFileAry;
	
	return($#$SegFileAry+1);
}
#####################################################################
# 2014.10.13 jdwang@asia.edu.tw
#####################################################################
#####################################################################
#
#
#####################################################################

sub ParsePubMed_XMLFile {
	
	my ($dbh,$InputFileLocation,$OutputFileLocation) = @_;
	
	open (FILEHANDLE,$InputFileLocation) or die "can't open $InputFileLocation";
				
	open (Output,">$OutputFileLocation") or die "can't open $OutputFileLocation";
			
	#
	# Initial the statistis of PubMed Articles
	#	
	#print "begin $FileLocation ".scalar localtime(time())."\n";#exit;
	my $TableName = 'Article';
	my $FieldName = 'PMID';
	
	
	my $TotalLen = 0;
	my $NewsCnt = 0;
	my $FileOver = 0; # Not ture 
	my $Linecnt = 0;
	while ((my $Line = <FILEHANDLE>) && ($FileOver==0))
	{   
			#print "$Line";
			$Linecnt++;
			my $OneArticle = "";
			if ($Line =~ /<PubmedArticle>/) {
				#print "(NewsCnt=$NewsCnt) Begin  $Linecnt =>$Line\n"; #exit;	
				$NewsCnt ++;
				chomp($Line);									
				$OneArticle = $Line;
				my $FoundEndNew = 0;
				#while ( (my $Line2 = <FILEHANDLE> )  &&  ($FoundEndNew == 0 ) && ($FileOver==0) ){
				while ( (my $Line2 = <FILEHANDLE> ) && ($FoundEndNew == 0 ) ){
					$Linecnt++;
					if ($Line =~ /<\/PubmedArticleSet>/) {
				   		$FileOver=1;
					} else {
						chomp($Line2);
						$OneArticle= $OneArticle.$Line2;
						 if ($Line2 =~ /<\/PubmedArticle>/) {
							 $FoundEndNew = 1;
							 #print "End  $Linecnt =>$Line2\n"; #exit;	
						} # end of 
					} # end of if ($Line =~ /<\/PubmedArticleSet>/) {
				} # end of while ($Line = <FILEHANDLE>)&&($FoundEndNew == 0)) {
				#print "$OneArticle\n";exit;
				if ($FoundEndNew == 1) {
					my ($OneArticleStr) = $OneArticle =~  /<PubmedArticle>(.+)<\/PubmedArticle>/;			
					
					my %OneArticleInfo = (); # Hash for storing the information of one article	
												
					ExtractArticleInfo($OneArticleStr,\%OneArticleInfo);
					
					#print Dumper(%OneArticleInfo);exit;
					
					my $DulplicatePMID = CheckPubMedIDExist($dbh,$OneArticleInfo{'PMID'},$TableName,$FieldName);
					
					#print Dumper(\%OneArticleInfo);exit;
					if ($DulplicatePMID == -1) { # It is a new PMID
					    RecordPMID($dbh,$TableName,\%OneArticleInfo);
						print Output "$OneArticleInfo{'PMID'}##$OneArticleInfo{'year'}-$OneArticleInfo{'month'}-$OneArticleInfo{'day'}##$OneArticleInfo{'ArticleTitle'}##$OneArticleInfo{'AbstractText'}\n";
					} else {
						print "$OneArticleInfo{'PMID'} Dulplicate!\n";
					}	
				} else {
					$FileOver=1;
				}
				
			} elsif ($Line =~ /<\/PubmedArticleSet>/) { # end of PubMed XML file
				$FileOver=1;
			}		
	} # end of while ((my $Line = <FILEHANDLE>) && ($FileOver==0))
	#print "end $FileLocation ".scalar localtime(time())."\n";
	close(FILEHANDLE);
	close(Output);
}
###########################################################
#
#
#
###########################################################
sub ParsePubMed_XMLFile_OneOutputFile {
	
	my ($dbh,$InputFileLocation,$fh_output) = @_;
	
	open (FILEHANDLE,$InputFileLocation) or die "can't open $InputFileLocation";
				
	#open (Output,">$OutputFileLocation") or die "can't open $OutputFileLocation";
			
	#
	# Initial the statistis of PubMed Articles
	#	
	#print "begin $FileLocation ".scalar localtime(time())."\n";#exit;
	my $TableName = 'Article';
	my $FieldName = 'PMID';
	
	
	my $TotalLen = 0;
	my $NewsCnt = 0;
	my $FileOver = 0; # Not ture 
	my $Linecnt = 0;
	while ((my $Line = <FILEHANDLE>) && ($FileOver==0))
	{   
			#print "$Line";
			$Linecnt++;
			my $OneArticle = "";
			if ($Line =~ /<PubmedArticle>/) {
				#print "(NewsCnt=$NewsCnt) Begin  $Linecnt =>$Line\n"; #exit;	
				$NewsCnt ++;
				chomp($Line);									
				$OneArticle = $Line;
				my $FoundEndNew = 0;
				#while ( (my $Line2 = <FILEHANDLE> )  &&  ($FoundEndNew == 0 ) && ($FileOver==0) ){
				while ( (my $Line2 = <FILEHANDLE> ) && ($FoundEndNew == 0 ) ){
					$Linecnt++;
					if ($Line =~ /<\/PubmedArticleSet>/) {
				   		$FileOver=1;
					} else {
						chomp($Line2);
						$OneArticle= $OneArticle.$Line2;
						 if ($Line2 =~ /<\/PubmedArticle>/) {
							 $FoundEndNew = 1;
							 #print "End  $Linecnt =>$Line2\n"; #exit;	
						} # end of 
					} # end of if ($Line =~ /<\/PubmedArticleSet>/) {
				} # end of while ($Line = <FILEHANDLE>)&&($FoundEndNew == 0)) {
				#print "$OneArticle\n";exit;
				if ($FoundEndNew == 1) {
					my ($OneArticleStr) = $OneArticle =~  /<PubmedArticle>(.+)<\/PubmedArticle>/;			
					
					my %OneArticleInfo = (); # Hash for storing the information of one article	
												
					ExtractArticleInfo($OneArticleStr,\%OneArticleInfo);
					
					#print Dumper(%OneArticleInfo);exit;
					
					my $DulplicatePMID = CheckPubMedIDExist($dbh,$OneArticleInfo{'PMID'},$TableName,$FieldName);
					
					#print Dumper(\%OneArticleInfo);exit;
					if ($DulplicatePMID == -1) { # It is a new PMID
					    RecordPMID($dbh,$TableName,\%OneArticleInfo);
						#print Output "$OneArticleInfo{'PMID'}##$OneArticleInfo{'year'}-$OneArticleInfo{'month'}-$OneArticleInfo{'day'}##$OneArticleInfo{'ArticleTitle'}##$OneArticleInfo{'AbstractText'}\n";	
						print $fh_output "$OneArticleInfo{'PMID'}##$OneArticleInfo{'year'}-$OneArticleInfo{'month'}-$OneArticleInfo{'day'}##$OneArticleInfo{'ArticleTitle'}##$OneArticleInfo{'AbstractText'}\n";
					} else {
						print "$OneArticleInfo{'PMID'} Dulplicate!\n";
					}	
				} else {
					$FileOver=1;
				}
				
			} elsif ($Line =~ /<\/PubmedArticleSet>/) { # end of PubMed XML file
				$FileOver=1;
			}		
	} # end of while ((my $Line = <FILEHANDLE>) && ($FileOver==0))
	#print "end $FileLocation ".scalar localtime(time())."\n";
	close(FILEHANDLE);
	#close(Output);
} # end of sub ParsePubMed_XMLFile_OneOutputFile
###########################################################
#
#
#
###########################################################
sub ExtractArticleInfo {
	my ($OneArticleStr,$OneArticleInfo) = @_;
	#print "(ExtractArticleInfo)\n$OneArticleStr\n";exit;
	
	# Extract "PMID"	
	if ($OneArticleStr =~ /<PMID>(\d+)<\/PMID>/ ){	
		$OneArticleInfo->{'PMID'} = $1;
	}	elsif ($OneArticleStr =~ /<PMID Version="\d+">(\d+)<\/PMID>/ ){
		$OneArticleInfo->{'PMID'} = $1;
	}   else {
		print "Error PMID format=>$OneArticleStr\n";exit;
	}	
	#
	# Extract the "Abstract"
	#
	if ($OneArticleStr =~ /<AbstractText>(.+)<\/AbstractText>/ ){
			$OneArticleInfo->{'AbstractText'} = $1;
	} elsif ($OneArticleStr =~ /<AbstractText NlmCategory=\"\w+\">(.+)<\/AbstractText>/){
			$OneArticleInfo->{'AbstractText'} = $1;
	} elsif (($OneArticleStr =~ /<AbstractText Label=\".+\" NlmCategory=\"\w+\">(.+)<\/AbstractText>/)) {
			# PMID = 25291347;
			#<AbstractText Label="GOALS:" NlmCategory="UNASSIGNED">To determine the prevalence and characteristics of lipomas in patients with Wilson disease.</AbstractText>
	        #<AbstractText Label="BACKGROUND:" NlmCategory="UNASSIGNED">Wilson disease is an autosomal recessive disorder resulting in copper accumulation in the liver and the central nervous tissue. Subcutaneous lipomas were often noted by the authors during clinical examinations of patients with Wilson disease. This is the first study to analyze the prevalence and progression of lipoma development in patients with Wilson disease.</AbstractText>
	        #<AbstractText Label="STUDY:" NlmCategory="UNASSIGNED">Eighty consecutive patients attending a tertiary care center were examined for the presence of subcutaneous lipomas.</AbstractText>
	        #<AbstractText Label="RESULTS:" NlmCategory="UNASSIGNED">Subcutaneous lipomas could be detected during the examination of 21 (26%) of the 80 patients with Wilson disease. Multiple subcutaneous lipomas were present in 16 (76%) of the 21 affected patients. Lipomas were mainly found on the extremities and the trunk. Neither initial presentation nor decoppering treatment influenced the presence or course of lipomas in these patients.</AbstractText>
	        #<AbstractText Label="CONCLUSIONS:" NlmCategory="UNASSIGNED">Subcutaneous lipoma formation is more common in patients with Wilson disease than in the general population. We suggest that the presence of lipomas contributes to the differential diagnosis of Wilson disease.</AbstractText>        
	        my ($TempStr) =  $OneArticleStr  =~ /<Abstract>(.+)<\/Abstract>/;
	        #print Dumper($TempStr);#exit;
		
	        my @Items = split (/<\/AbstractText>/,$TempStr);
	        #print Dumper(@Item);exit;
	        my $TempStr = "";
	        foreach my $OneItem (@Items) {
		        #print "$OneItem\n";exit;
		        my ($Label,$Temp) = $OneItem =~ /<AbstractText Label=\"(.+)\" NlmCategory=\"\w+\">(.+)/;
		        #print "$Temp\n\n";exit;
		        $TempStr = $TempStr.$Label." ".$Temp." ";
	        }     
	        #print Dumper($TempStr);exit;     
	        $OneArticleInfo->{'AbstractText'} = $TempStr;
	} else {
			#print "PMID=$OneArticleInfo->{'PMID'} Error=>Abstract\n";
			#exit;
	} # end of if ($OneArticleStr =~ /<AbstractText>(.+)<\/AbstractText>/ )
	#
	# Extract the "Title"
	#
	if ($OneArticleStr =~ /<ArticleTitle>(.+)<\/ArticleTitle>/ ){
			$OneArticleInfo->{'ArticleTitle'} = $1;
	} else {
			$OneArticleInfo->{'ArticleTitle'} = "";#exit;
	}
	#print Dumper($OneArticleInfo);exit;
	#
	# Extract the PubDate "Year Month Day"
	#
	#my ($TargetDateStr) = $OneArticleStr =~ /<PubMedPubDate PubStatus="\w+">(.+)<\/PubMedPubDate>/;
	my ($TargetDateStr) = $OneArticleStr =~ /<PubMedPubDate PubStatus="pubmed">(.+)<\/PubMedPubDate>/;	
	if ($TargetDateStr ne '') {
			$TargetDateStr =~ s/ //g;			
			my ($year,$month,$day) = $TargetDateStr =~ /<Year>(\d+)<\/Year><Month>(\d+)<\/Month><Day>(\d+)<\/Day>/;		
			#print Dumper($year,$Month,$day);exit;	
			
			if (length($year)==4) {
				$OneArticleInfo->{'year'} = $year;		
				$OneArticleInfo->{'month'} = MonthStrMapping($month); # There might be different types of "Month", e.g. "1" "01" and "Jan" 	
				$OneArticleInfo->{'day'} = $day;			
				#print Dumper($OneArticleInfo);exit;				
			} else {
				print "FindPubDate=>(PID:$OneArticleInfo->{'PMID'})(Year:$year)!\n";exit;
			} # end of if (length($year)==4
	} else {
			print "$OneArticleInfo->{'PMID'}=>TargetDateStr: Error \n"; exit;
	}	# end of if ($TargetDateStr ne '') 
} # end of sub ExtractArticleInfo

##################################################
#
##################################################
sub CheckPubMedIDExist {
	my ($dbh,$PuMedID,$TableName,$FieldName) = @_;
	
	my $Condition = "$FieldName = $PuMedID";
	my $sql = "Select PMID from ".$TableName." where ".$Condition;
	my $sth = $dbh->prepare( $sql) or die "\n can't prepare ($sql)\n";
	$sth->execute  or die "\n can't execute ($sql)\n";;
	
	my $ID = 'NoBody';
	while ( my @row = $sth->fetchrow_array )
	{
   	 	#print Dumper(@row)."\n";
    	$ID = $row[0];
	}	
	$sth->finish;
	
	#print Dumper($ID);exit;
	if ($ID eq 'NoBody'){ # Not Exist
		return(-1);
	} else {
		return(1); #  Exist
	}
} # end of sub CheckPubMedIDExist
###################################################
sub  RecordPMID {
	my ($dbh,$TableName,$OneArticleInfo) = @_;
	
	my $PMID = $OneArticleInfo->{'PMID'};
	my $PubDate_Year = $OneArticleInfo->{'year'};
	my $PubDate_Month = $OneArticleInfo->{'month'};
	my $PubDate_Day = $OneArticleInfo->{'day'};
	my $Title = $OneArticleInfo->{'ArticleTitle'};
	my $Abstract = $OneArticleInfo->{'AbstractText'};
					
	$Title =~ s/\[//g;
	$Title =~ s/\]//g;
	$Title =~ s/\\//g;
	$Title =~ s/\'/\\\'/g;
	$Title =~ s/\.//g;
					
	$Abstract =~ s/\[//g;
	$Abstract =~ s/\]//g;
	$Abstract =~ s/\\//g;
	$Abstract =~ s/\'/\\\'/g;
	$Abstract =~ s/\.//g;
	#print Dumper($Abstract);exit;
	my $Values = "PMID=$PMID,PubDate_Year=$PubDate_Year,PubDate_Month=$PubDate_Month,PubDate_Day=$PubDate_Day,Title='$Title',Abstract='$Abstract'";
								
	my $sql = "insert into ".$TableName." set ".$Values;
	#print Dumper($sql);exit;
	my $sth = $dbh->prepare( $sql) or die "\n can't prepare ($sql)\n";
	$sth->execute  or die "\n can't execute ($sql)\n";;
	$sth->finish;
	#exit;
}
#######################################
#######################################
sub MonthStrMapping {
		my ($MonthTransfer) = @_;
		
		$MonthTransfer->{'00'} = '0';
		$MonthTransfer->{'Jan'} = '1';
		$MonthTransfer->{'Feb'} = '2';
		$MonthTransfer->{'Mar'} = '3';
		$MonthTransfer->{'Apr'} = '4';
		$MonthTransfer->{'May'} = '5';
		$MonthTransfer->{'Jun'} = '6';
		$MonthTransfer->{'Jul'} = '7';
		$MonthTransfer->{'Aug'} = '8';
		$MonthTransfer->{'Sep'} = '9';
		$MonthTransfer->{'Oct'} = '10';
		$MonthTransfer->{'Nov'} = '11';
		$MonthTransfer->{'Dec'} = '12';
		
		$MonthTransfer->{'1'} = '1';
		$MonthTransfer->{'2'} = '2';
		$MonthTransfer->{'3'} = '3';
		$MonthTransfer->{'4'} = '4';
		$MonthTransfer->{'5'} = '5';
		$MonthTransfer->{'6'} = '6';
		$MonthTransfer->{'7'} = '7';
		$MonthTransfer->{'8'} = '8';
		$MonthTransfer->{'9'} = '9';
		$MonthTransfer->{'01'} = '1';
		$MonthTransfer->{'02'} = '2';
		$MonthTransfer->{'03'} = '3';
		$MonthTransfer->{'04'} = '4';
		$MonthTransfer->{'05'} = '5';
		$MonthTransfer->{'06'} = '6';
		$MonthTransfer->{'07'} = '7';
		$MonthTransfer->{'08'} = '8';
		$MonthTransfer->{'09'} = '9';
		$MonthTransfer->{'10'} = '10';
		$MonthTransfer->{'11'} = '11';
		$MonthTransfer->{'12'} = '12';			
} # end of sub MonthStrMapping



return(1);
